﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Core;
using HeuristicLab.Common;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Data;
using HeuristicLab.Parameters;

namespace HeuristicLab.PDPSimulation.DistanceMeasures {
  [StorableClass]
  public class DistanceMatrixData: ParameterizedNamedItem, IStorableContent {
    public ValueParameter<DoubleMatrix> DistanceMatrixParameter {
      get { return (ValueParameter<DoubleMatrix>)Parameters["DistanceMatrix"]; }
    }

    public DoubleMatrix DistanceMatrix {
      get {
        return DistanceMatrixParameter.Value;
      }

      set {
        DistanceMatrixParameter.Value = value;
      }
    }

    public ValueParameter<IntMatrix> PointMappingParameter {
      get { return (ValueParameter<IntMatrix>)Parameters["PointMapping"]; }
    }

    public IntMatrix Mapping {
      get {
        return PointMappingParameter.Value;
      }

      set {
        PointMappingParameter.Value = value;
      }
    }

    public DistanceMatrixData()
      : base() {
        Parameters.Add(new ValueParameter<DoubleMatrix>("DistanceMatrix", new DoubleMatrix()));
        Parameters.Add(new ValueParameter<IntMatrix>("PointMapping", new IntMatrix()));
    }
    [StorableConstructor]
    private DistanceMatrixData(bool deserializing) : base(deserializing) {
    }
    private DistanceMatrixData(DistanceMatrixData original, Cloner cloner)
      : base(original, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new DistanceMatrixData(this, cloner);
    }
    
    #region IStorableContent Members

    public string Filename {
      get;
      set;
    }

    #endregion
  }
}
